<?php

include '../core.php';

session_start();

cabecera (1);

// Controles ActiveX de microsoft que contienen la libreria de enlace dinamico
// XEnroll.dll encargada de generar la clave privada. Tambien se incluye el
// script vbs que contiene las funciones encargadas de manejar la libreria
// XEnroll.dll. Una de ellas es enumCSP(), la cual muestra un listado con todos
// los proveedores criptograficos.
echo "<!-- Use the Microsoft ActiveX control to install the certificate -->
  <object
    classid='clsid:43f8f289-7a20-11d0-8f06-00c04fc295e1'
    codebase='/xenroll.dll'
    id=certHelperOld>
  </object>
  <object
    classid='clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1'
    codebase='/xenroll.dll'
    id=certHelperNew>
  </object>
";

echo "

  <script type='text/vbscript' src='ie/ieCSR.vbs'></script>

  <body onload='enumCSP()'>";

// El siguiente script se encarga de comprobar que los datos 
// de un formulario son validos antes de enviarlos 
echo "<script type='text/javascript'>
<!--
function submit_form()
{
  if (document.csr_form.csr_ID_name.value == '' ||
      document.csr_form.csr_ID_name.value.search(/[^a-z,A-Z,0-9,\.,_,\-]/i) >= 0 ||
      document.csr_form.csr_ID_name.value == 'nombre.apellido' )
  {
    alert ('Por favor introduzca un Identificador correcto. Solo puede escribir caracteres de la \'a\' a la \'z\', 	números y signos \'.\', \'-\' y \'_\'');
    document.csr_form.csr_ID_name.focus();
    return false;
  }
  if (document.csr_form.csr_cn.value == '')
  {
    alert ('Por favor introduzca su nombre');
    document.csr_form.csr_cn.focus();
    return false;
  }
  if (document.csr_form.csr_sn1.value == '')
  {
    alert ('Por favor introduzca su primer apellido');
    document.csr_form.csr_sn1.focus();
    return false;
  }
  if (document.csr_form.csr_sn2.value == '')
  {
    alert ('Por favor introduzca su segundo apellido');
    document.csr_form.csr_sn2.focus();
    return false;
  }
  if (document.csr_form.csr_telf.value == '')
  {
    alert ('Por favor introduzca su teléfono de contacto');
    document.csr_form.csr_telf.focus();
    return false;
  }
  if ( document.csr_form.csr_mail.value == '' ||
       document.csr_form.csr_mail.value.search(/[^a-z,A-Z,0-9,\.,_,@,\-]/i) >= 0 ||
       document.csr_form.csr_mail.value.indexOf('@') == -1 ||
       document.csr_form.csr_mail.value.indexOf('.') == -1)
  {
    alert ('Por favor introduzca una dirección de correo electrónico válida');
    document.csr_form.csr_mail.focus();
    return false;
  }
  if (document.csr_form.csr_pass.value == '' || document.csr_form.csr_pass2.value == '')
  {
    alert ('Por favor introduzca las dos claves');
    document.csr_form.csr_pass.focus();
    return false;
  }
  if (document.csr_form.csr_pass.value != document.csr_form.csr_pass2.value)
  {
    alert ('Las dos claves no coinciden');
    document.csr_form.csr_pass.focus();
    return false;
  }
						    
  
  if (document.csr_form.csr_pw1.value == '' || document.csr_form.csr_pw2.value == '')
  {
    alert ('Por favor introduzca los dos PINes');
    document.csr_form.csr_pw1.focus();
    return false;
  }
  if (document.csr_form.csr_pw1.value != document.csr_form.csr_pw2.value)
  {
    alert ('Los dos PINes no coinciden');
    document.csr_form.csr_pw1.focus();
    return false;
  }
  document.csr_form.submit();
  return true;
}

function removeNameSubname() {
   document.csr_form.csr_ID_name.value='';
   return true;
}
// -->
</script>\n";

// En esta variable guardaremos el estado de la solicitud 
// (rellenandose, verificandose o enviandose). Dependiendo de
// su valor, entraremos en una u otra parte del codigo
$command = $_POST ['csr_command'];
$csrtype = $_GET ['type'];
$status = "new";
$errorCode = "a0";

switch ( $command ) {

  // Por defecto se muestra un formulario para que lo rellene el usuario    
  default:
   // Antes de nada, guardamos en una variable el tipo de navegador
   $browser = getBrowser();
   if ( !$browser ) 
      $errorCode = "MIRAR";
   // Comprobamos que se haga la solicitud desde un navegador soportado
   else if ( $browser == "moz" || $browser == "ie" ) {

     if (isset ($_POST['invalid_id']) && ($_POST['invalid_id'] == true) ) 
	$errorCode = "a4b2c1d2e1";
     
     if ($csrtype == "usr") {

        echo "<h1>Solicitud de Certificado</h1>
	<div id='tbox'>
	   <h3 class='head_a2b1'>Certificado de Usuario</h3>
	      <div id='tbox_data_a1'>
              <form method='post' action='csr_new.php?type=usr' enctype='multipart/form-data' name='csr_form'>
              <p>Autoridad de Registro: <b>$raName</b></p>
              <div id='trow'>
                 <div id='tname'>	
	            <a href='help/help.php#identificador'>Identificador</a>
                 </div>
                 <div id='tvalue'>
                    <input class='form_input' type='text' name='csr_ID_name'  size='25'  minlen='7' value='nombre.apellido' onfocus='removeNameSubname()'/>  <b>@</b>
	            <select name='domain'>";
                       while (list ($index) = each ($raDomains)) 
 	                  echo "<option>$index</option>";
                          echo "</select>
                 </div>
              </div>
	      <div id='trow'>
                 <div id='tvalue'>Por favor, escriba su <tt><b>nombre.apellido</b></tt><br/>&nbsp;</div>
              </div>
              <div id='trow'>
                 <div id='tname'>Nombre</div>
                 <div id='tvalue'>
	            <input class='cajaTexto' type='text' name='csr_cn'  value='".$_POST['csr_cn']."' size='40' />
                </div>
              </div>	      
              <div id='trow'>
                 <div id='tname'>Primer apellido</div>
                 <div id='tvalue'>
                    <input class='cajaTexto' type='text' name='csr_sn1'  value='".$_POST['csr_sn1']."' size='40' />
                 </div>
	       </div>
	       <div id='trow'>
                 <div id='tname'>Segundo apellido</div>
                 <div id='tvalue'>
                    <input class='cajaTexto' type='text' name='csr_sn2'  value='".$_POST['csr_sn2']."' size='40' />
                 </div>
               </div>
	       <div id='trow'>
                 <div id='tname'>Tel&eacute;fono</div>
                 <div id='tvalue'>
                    <input class='cajaTexto' type='text' name='csr_telf'  value='".$_POST['csr_telf']."' size='40' />
                 </div>
               </div>
               <div id='trow'>
                  <div id='tname'>email</div>
                  <div id='tvalue'>
	             <input class='cajaTexto' type='text' name='csr_mail' value='".$_POST['csr_mail']."' size='40' />
                  </div>
               </div>
<br/>&nbsp;
               <div id='trow'>
                  <div id='tname'>
                     <a href='help/help.php#clave_usuario'>Clave de Usuario</a>
		  </div>
                  <div id='tvalue'>
	             <input class='cajaTexto' type='password' name='csr_pass'  size='40' />
                  </div>
	       </div>
               <div id='trow'>
                  <div id='tname'>Repita la clave</div>
	          <div id='tvalue'>
	             <input class='cajaTexto' type='password' name='csr_pass2'  size='40' /><br/>&nbsp;
                  </div>
               </div>
	       <div id='trow'>
                  <div id='tname'><a href='help/help.php#crt_pin'>PIN</a></div>
	          <div id='tvalue'>
	             <input class='cajaTexto' type='password' name='csr_pw1'  size='40' />
                  </div>
               </div>
               <div id='trow'>
                  <div id='tname'><a href='help/help.php#crt_pin'>Repita PIN</a></div>
                  <div id='tvalue'>
                     <input class='cajaTexto' type='password' name='csr_pw2'  size='40' />
                  </div>
                </div>
<br/>&nbsp;
                <div id='trow'>
                   <div id='tname'>Privacidad</div>
	           <div id='tvalue'>&iquest;Desea <a href=help/help.php#show_mail'>incluir su email en el certificado</a>?
		      <input type='radio' name='csr_showMail'  value='FALSE' checked> No
		      <input type='radio' name='csr_showMail'  value='TRUE'> Si
                   </div>
                </div>
	        <div id='trow'>
	           <div id='tvalue'><input class='button' type='button' value='Continuar' onclick='submit_form()' /></div>
                </div>
             <input type='hidden' name='csr_nav_type' value='$browser' />
	     <input type='hidden' name='csr_command' value='csr_vrf' />
             </form>
	  </div> <!-- tbox_data_a1 -->
       </div> <!-- tbox -->";		
     }

     else {
   
        echo "<h1>Solicitud de Certificado</h1>
        <div id='tbox'>
	   <h3 class='head_a2b1'>Certificado de Servidor</h3>
	      <div id='tbox_data_a1'>
      	      <form method='post' action='csr_new.php?type=srv' enctype='multipart/form-data' name='csr_form'>
      	      <p>Autoridad de Registro: <b>$raName</b></p>
	      <div id='trow'>
	         <div id='tname'><a href='help/help.php#identificador'>Identificador</a></div>
	         <div id='tvalue'>
		    <input class='form_input' type='text' name='csr_service'  size='8' /> /
	            <input class='form_input' type='text' name='csr_ID_name'  size='17' /> .
	            <select name='domain'>";
                    while (list ($index) = each ($raDomains)) 
                    echo "<option>$index</option>";
                    echo "</select>
	         </div>
	      </div>
	      <p>Datos del Responsable</p>
	      <div id='trow'>
                 <div id='tname'>Nombre</div>
		 <div id='tvalue'>
                    <input class='cajaTexto' type='text' name='csr_cn'  value='".$_POST['csr_cn']."' size='30' />
		 </div>
              </div>
	      <div id='trow'>
                 <div id='tname'>Primer apellido</div>
                 <div id='tvalue'>
                    <input class='cajaTexto' type='text' name='csr_sn1'  value='".$_POST['csr_sn1']."' size='30' />
                 </div>
               </div>
	      <div id='trow'>
                 <div id='tname'>Segundo apellido</div>
                 <div id='tvalue'>
                    <input class='cajaTexto' type='text' name='csr_sn2'  value='".$_POST['csr_sn2']."' size='30' />
                 </div>
              </div>
	      <div id='trow'>
	         <div id='tname'><a href='help/help.php#clave_usuario'>Clave de Usuario</a></div>
		 <div id='tvalue'>
  	            <input class='cajaTexto' type='password' name='csr_pass' size='20' />
		 </div>
	      </div>
	      <div id='trow'>
	         <div id='tname'>Repita la clave</div>
		 <div id='tvalue'>
                    <input class='cajaTexto' type='password' name='csr_pass2'  size='20' /><br/>&nbsp;
		 </div>
	      </div>
	      <div id='trow'>
	         <div id='tname'>Tel&eacute;fono</div>
		 <div id='tvalue'>
	            <input class='cajaTexto' type='text' name='csr_telf'  value='".$_POST['csr_telf']."' size='20' />
		 </div>
	      </div>
	      <div id='trow'>
	         <div id='tname'>email</div>
		 <div id='tvalue'>
	            <input class='cajaTexto' type='text' name='csr_mail' value='".$_POST['csr_mail']."' size='30' />
		 </div>
	      </div>
	      <div id='trow'>
	         <div id='tname'>PIN</div>
		 <div id='tvalue'>
	            <input class='cajaTexto' type='password' name='csr_pw1'  size='16' />
		 </div>
	      </div>
	      <div id='trow'>
	         <div id='tname'>Repite PIN</div>
		 <div id='tvalue'>
	            <input class='cajaTexto' type='password' name='csr_pw2'  size='16' />
		 </div>
	      </div>
	      <div id='trow'>
                 <div id='tvalue'>
		    <input class='button' type='button' value='Continuar' onclick='submit_form()' />
                 </div>
	      </div> 
              <input type='hidden' name='csr_nav_type' value='$browser' />             
	      <input type='hidden' name='csr_command' value='csr_vrf' />
              </form>
          </div> <!-- tbox_data_a1 -->
       </div> <!-- tbox -->";

     }
   }
   else  
      $errorCode = "a4b2c1d2e2";
	
      break;

   case "csr_vrf": // Una vez rellenado, se muestran los datos del 
                   // formulario para que el usuario los verifique

	// Antes de nada, tendremos que comprobar que el identificador
        // introducido por el usuario sea valido, es decir, que cumpla la
        // expresion regular definida en el archivo de configuracion de la RA 
	$domain = $_POST['domain'];	
	$csr_ID_name = $_POST['csr_ID_name'];
        $regexp = $raDomains[$domain]['validDomainRegexp'];
	
        // Si no la cumple, devolvemos al usuario al apartado anterior para que
	// introduzca otro identificador
        if (!ereg($regexp,$csr_ID_name)) {
           echo "<form method='post' action='csr_new.php?type=$csrtype' enctype='multipart/form-data' name='invalid_id_form'>
           <input type='hidden' name='csr_cn'       value='".$_POST['csr_cn']."' />
           <input type='hidden' name='csr_sn1'      value='".$_POST['csr_sn1']."' />
  	   <input type='hidden' name='csr_sn2'      value='".$_POST['csr_sn2']."' />
           <input type='hidden' name='csr_telf'     value='".$_POST['csr_telf']."' />
           <input type='hidden' name='csr_mail'     value='".$_POST['csr_mail']."' />
	   <input type='hidden' name='invalid_id'   value='true' />
	   <input type='hidden' name='csr_command' value='' />
           <script type='text/javascript'>document.invalid_id_form.submit();</script>";
	}
	// Si la cumple, seguimos adelante
        else{
	   if ($csrtype == "usr" ){
	      $csr_ID = $csr_ID_name . "@" . $domain;
	      $dn = $ldapVar['baseCrt'] . $raDomains[$domain]["domain"] . "cn=" . $csr_ID_name;
	   }
	   else {
 	      // Si es una csr de un servicio, le anyadimos su identificador al principio del 
	      // identificador de la solicitud 
	      if ( isset($_POST['csr_service']) && $_POST['csr_service'] != '' )
	         $csr_ID = $_POST['csr_service'] . "/" . $csr_ID_name . "." . $domain;
	      else
	         $csr_ID = $csr_ID_name . "." . $domain;

	      $dn = $ldapVar['baseCrt'] . $raDomains[$domain]['domain'] . "cn=" . $csr_ID;
	   }
           // Mostramos los datos de la solicitud
	   echo "
		<div id='tbox'>
		<h3 class='head_a2b1'>Solicitud</h3>
		<div id='tbox_data_a2'>
		  <div id='trow'>
		    <div id='tname'>Subject DN</div>
		    <div id='tvalue'>$dn</div>
		  </div>
		  <div id='trow'>
		    <div id='tname'>Identificador</div>
		    <div id='tvalue'>$csr_ID</div>
		  </div>
		  <div id='trow'>
		    <div id='tname'>Nombre</div>
		    <div id='tvalue'>".$_POST['csr_cn'] . " " . $_POST['csr_sn1'] . " " . $_POST['csr_sn2']."</div>
		  </div>
		  <div id='trow'>
		    <div id='tname'>Mail</div>
		    <div id='tvalue'>".$_POST['csr_mail']."</div>
		  </div>
		  <div id='trow'>
		    <div id='tname'>Tel&eacute;fono</div>
		    <div id='tvalue'>".$_POST['csr_telf']."</div>
		  </div>
		</div>\n";

                // Dependiendo del tipo de navegador, generaremos la clave
                // privada de una manera u otra.
                $nav_type = $_POST['csr_nav_type'];
                if ($nav_type == "moz" ) {
                   echo "	
                        <form method='post' action='csr_new.php' enctype='multipart/form-data' name='pkIRIS'>	
		        <div id='tbox_data_a1'>
		          <div id='trow'>
		          <div id='tname'>Tama&ntilde;o de la clave</div>
		            <div id='tvalue'>
		              <KEYGEN NAME='newkey' CHALLENGE='NO_CHALLENGE'>&nbsp;&nbsp;
		              (se recomienda 2048 bits)
		            </div>
		          </div>

		             <input type='hidden' name='request'      value='' />
		             <input type='hidden' name='csr_nav_type' value='spkac' />
		             <input type='hidden' name='csr_type'     value='$csrtype' />
		             <input type='hidden' name='csr_ID'       value='$csr_ID' />
		             <input type='hidden' name='subjectDN'    value='$dn' />
		             <input type='hidden' name='csr_pass'     value='".$_POST['csr_pass']."' />
		             <input type='hidden' name='csr_pw1'      value='".$_POST['csr_pw1']."' />
		             <input type='hidden' name='csr_pw2'      value='".$_POST['csr_pw2']."' />
		             <input type='hidden' name='csr_cn'       value='".$_POST['csr_cn']."' />
		             <input type='hidden' name='csr_sn1'      value='".$_POST['csr_sn1']."' />
		             <input type='hidden' name='csr_sn2'      value='".$_POST['csr_sn2']."' />
		             <input type='hidden' name='csr_telf'     value='".$_POST['csr_telf']."' />
		             <input type='hidden' name='csr_mail'     value='".$_POST['csr_mail']."' />
		             <input type='hidden' name='csr_showMail' value='".$_POST['csr_showMail']."' />
		             <input type='hidden' name='csr_command'  value='csr_add' />

		           <div id='trow'>
		             <div id='tvalue'>
		               <input class='button' type='submit' value='Continuar' />
		             </div>
		           </div>
		           </form>

		        </div> <!-- tbox_data_a1 -->
		        </div> <!-- tbox -->\n";
                }
                else if ( $nav_type == "ie" ) {
                    echo "
			  <h3>Proveedor Criptogr&aacute;fico<br><br></h3>
			  <form method='post' action='csr_new.php' enctype='multipart/form-data' name='pkIRIS'>
                            <select name='csp' size='1' id='csp'>
                              <option value='' selected>Default</option>
                            </select>
                          <input type='hidden' name='request'      value='' />
                          <input type='hidden' name='csr_nav_type' value='ie' />
                          <input type='hidden' name='csr_type'     value='$csrtype' />
                          <input type='hidden' name='csr_ID'       value='$csr_ID' />
                          <input type='hidden' name='subjectDN'    value='$dn' />
                          <input type='hidden' name='csr_pass'     value='".$_POST['csr_pass']."' />
                          <input type='hidden' name='csr_pw1'      value='".$_POST['csr_pw1']."' />
                          <input type='hidden' name='csr_pw2'      value='".$_POST['csr_pw2']."' />
                          <input type='hidden' name='csr_cn'       value='".$_POST['csr_cn']."' />
                          <input type='hidden' name='csr_sn1'      value='".$_POST['csr_sn1']."' />
                          <input type='hidden' name='csr_sn2'      value='".$_POST['csr_sn2']."' />
                          <input type='hidden' name='csr_telf'     value='".$_POST['csr_telf']."' />
                          <input type='hidden' name='csr_mail'     value='".$_POST['csr_mail']."' />
                          <input type='hidden' name='csr_showMail' value='".$_POST['csr_showMail']."' />
                          <input type='hidden' name='csr_command'  value='csr_add' />
                          <input type='button' value='Continuar'   onclick='GenReq()'>
                          </form>\n";
                }
        }
	
        break;

   case "csr_add": // Despues de comprobar los datos, se envia la solicitud a la Ra
        echo "<h1 class='title'>Solicitud de Certificado</h1>";
	$errorCode = "a0";
	// Hacemos esto para quitar los saltos de linea y que el openssl no de 
	// error a la hora de firmar la CSR
	$newkey = str_replace ("\r\n", "", $_POST['newkey']);
	
	$cn = strtolower($_POST['csr_ID']);
             	
	$filter = "(&(objectclass=pkirisAuthority)(pkirisCopaID=$raNum))";
        $justthese = array ("count");
        $result = ldap_get_info($ldapVar['base'], $filter, $justthese);

	if (!$result)
	   $errorCode = "a4b2c1d1e1";
	else {
	   // Comprobamos que existe la RA en el ldap
	   if ($result["count"] != 0) {
	      // Buscamos cuantos certificados tiene el usuario
	      $filter = "(&(objectclass=pkirisEndEntity)(pkirisID=".$_POST['csr_ID']."))";
	      $result = ldap_get_info($ldapVar['base'], $filter, $justthese);
	      
	      if (!$result)
                 $errorCode = "a4b2c1d1e1";
	      else {
	         //Si es el primer certificados que solicita el usuario
                 if ($result["count"] == 0) {
		    // Miramos el contador de la Ra para saber la cantidad de usuarios que hay
	            // Con este numero y el de la Ra formaremos el codigo copa
                    $numUsr = getCounter ($raNum) + 1;
		    if ( !$numUsr ) 
		       $errorCode = "a4b2c1d2e4";
		    else {
	               $copaUsr = $raNum . "b" . $numUsr;
	               $copa = $raNum . "b" . $numUsr . "c1";
	      	       // Preparamos los datos de usuario
	               $info["objectClass"][0]="top";
	               $info["objectClass"][1]="irisObject";
	               $info["objectClass"][2]="pkirisEndEntity";
	               $info["objectClass"][3]="irisPerson";
	               $info[$ldapVar['rdnAttr']]=$copaUsr;
	               $info["pkirisID"]=$_POST['csr_ID'];
	               $info["sn"]=$_POST['csr_sn1'] . " " . $_POST['csr_sn2'];
	               $info["sn1"]=$_POST['csr_sn1'];
	               $info["sn2"]=$_POST['csr_sn2'];
	               $info["cn"]=$_POST['csr_cn'];
	               $info["telephoneNumber"]=$_POST['csr_telf'];
	               $info["mail"]=$_POST['csr_mail'];
	               $info["pkirisCopaID"]=$copaUsr;
      	               $info["pkirisCounter"]="0";
	               $info["userPassword"]="{crypt}".crypt($_POST['csr_pass']);
      	               $info["irisUserEntitlement"]=$pkiris['urnEntitlementPrefix']."$raUrl:user";
	      
	               // Guardamos la informacion del ususario que hace la CSR
	               $r=ldap_add_info($ldapVar['rdnAttr']."=".$copaUsr.",".$ldapVar['base'], $info);	
	               if (!$r)
	                  $errorCode = "a4b2c1d1e2";
		       else {
		          // Incrementamos el contador de usuarios de la Ra correspondiente
	                  $r = incrCounter($raNum);
	                  if (!$r)
		    	     $errorCode = "a4b2c1d2e3";
	               }
	            }
		 }
	      	 
   	         // Si el usuario ha solicitado otro certificado anteriormente
	         else {   
	            // Buscamos el pkiId del usuario	      
	            $filter = "(&(objectclass=pkirisEndEntity)(pkirisID=".$_POST['csr_ID']."))";
	            $justthese = array ("pkiriscopaid");
	            $idUser = ldap_get_info($ldapVar['base'], $filter, $justthese);
	            if (!$idUser) 
		       $errorCode = "a4b2c1d1e1";
		    else {
		       // Contamos cuantos CRS ha pedido este usuario para formar el codigo copa    
	               $copaUsr = $idUser[0]["pkiriscopaid"][0];	
	               $certCount = getCounter ($copaUsr) + 1;
	               if ( !$certCount )
		          $errorCode = "a4b2c1d2e4";
	      	       else {
	                  // Comprobamos si el usuario tiene otros certificados firmados o pendientes de ser firmados
	                  for ($i = 1; $i < $certCount; $i++){
		             $copa = $copaUsr. "c" . $i;
  	                     $lastStatus = getStatus ($copa);
                             if ( !$lastStatus )
				$errorCode = "a4b2c1d2e6";
                             else { 		
		                if ($lastStatus == "issued") 
		                   $errorCode = "a4b2c1d2e7";
		                else if ($lastStatus == "new" || $lastStatus == "ca2ra" || $lastStatus == "approved" || $lastStatus == "revoke") 
		                $errorCode = "a4b2c1d2e8";
                             }
	                  }
			  // El codigo copa de la solicitud sera el del usuario
			  // con la 'c' de la ultima solicitud +1 del servidor 
			  // ldap
	                  $copa = $copaUsr . "c" . $certCount;
                       }
	            }
	         }
	      }
	   }
	   else 
	      $errorCode = "No existe ninguna RA.";
	}
        // Si no se ha producido ningun error, guardamos en el ldap los datos
	// de la solicitud
	if ( $errorCode == "a0" ) {
           // Preparamos los datos necesarios para generar la traza      
           $currentDate = date("YmdHis");
   	   $dn = $ldapVar['rdnAttr']."=".$copa.",".$ldapVar['base'];

	   $traceVals["status"] = $status;
	   $traceVals["copa"] = $copa;
	   $traceVals["currentDate"] = $currentDate;

	   // Generamos la traza con los valores de $traceVals
	   $pkiTrace = getTrace($traceVals);							     
	   if ( !$pkiTrace )
	      $errorCode = "a4b2c1d2e5";
	   else {
      	      // Preparamos los datos que se escribiran en el ldap
	      $info1["objectClass"][0]="top";
	      $info1["objectClass"][1]="irisObject";
	      $info1["objectClass"][2]="pkirisCertificate";
	      $info1[$ldapVar['rdnAttr']]=$copa;
	      $info1["pkirisID"]=$_POST['csr_ID'];
	      $info1["pkirisTrace"]=$pkiTrace;
	      $info1["pkirisStatus"]=$status;
	      $info1["pkirisDate"]=$currentDate;
	      $info1["pkirisPin"]=crypt($_POST['csr_pw1']);              
              // Dependiendo del navegador, la CSR sera de un tipo u otro
              $nav_type = $_POST['csr_nav_type'];              
              if ( $nav_type == "spkac" )
 	         $info1["pkirisCSR"]="SPKAC=" . $newkey;
              else if ( $nav_type == "ie" )
                 $info1["pkirisCSR"]="-----BEGIN CERTIFICATE REQUEST-----\n". $_POST['request'] ."-----END CERTIFICATE REQUEST-----";
	      $info1["pkirisCertType"]=$_POST['csr_type'];
	      $info1["pkirisSubjectDN"]=$_POST['subjectDN'];
	      $info1["pkirisCopaID"]=$copa;
              $info1["mail"] = $_POST['csr_mail'];
	   
	      // Si la CSR es de usuario, solo mostraremos el mail en el 
	      // certificado si el usuario lo autoriza
              if( ($_POST['csr_type'] == "usr") ) 
                 $info1["pkirisshowmail"] = $_POST['csr_showMail'];          
	      // En las de tipo servidor nunca se mostrara el mail
	      else
	         $info1["pkirisshowmail"] = "FALSE";

    	      // Guardamos la informacion de la CSR	
	      $r=ldap_add_info($dn, $info1);
	      
	      if (!$r)
                 $errorCode = "a4b2c1d1e1";
	      else {
		 // Incrementamos el contador del numero de certificados del usuario
                 $r = incrCounter ($copaUsr);

                 if (!$r)
                    $errorCode = "a4b2c1d2e3";
		 else {
		    // Le enviamos al administrador un email para avisarle de que tiene una nueva CSR
	            $envioMail = mail($ldapVar['adminRaMail'], "Nueva CSR", "Se ha creado una nueva CSR con identificador: $cn\n");
                    echo "<h2> Solicitud Aceptada </h2>
                    <p> Su solicitud: </p>
                    <ul>
                    <li> Identificador: ".$_POST['csr_ID']." </li>
		    <li> C&oacute;digo de solicitud: $copa </li>
                    </ul>
                    <p> ha sido aceptada. </p>
                    <p> Por favor es muy importante que anote los valores anteriores ya que le ser&aacute;n de utilidad a la hora de las siguientes operaciones:</p>
                    <ul>
                    <li> Autenticaci&oacute;n frente a la autoridad de registro. </li>
                    <li> Descarga de su certificado. </li>
                    <li> Revocaci&oacute;n de su certificado. </li>
                    </ul>\n";
		
		    // Registramos la accion en el fichero de log
                    $pkiLog['status'] = $status;
                    $pkiLog['eee'] = $copa;
                    $pkiLog['user'] = "Publico";
                    $pkiLog['error'] = $errorCode;
                    writeLog ($pkiLog);
           	 }
	      }
	   }
	}
        break;
}

// Si se ha producido algun error, llamamos a la funcion encargada de
// tratarlos
if ( $errorCode != "a0" ) {
   echo "<h2> Error en la Solicitud de Certificado </h2>
         <p> No ha sido posible generar su solicitud.</p>\n";

   $pkiLog['eee'] = $copa;
   $pkiLog['user'] = "Publico";
   $pkiLog['error'] = $errorCode;  
   pkirisErrorHandler($pkiLog);
}

pie ();

?>

